#include<iostream>
using namespace std;
typedef long long ll;



template<int N>
struct ftree{
	ll data[N];
	
	
	//Segment query
	ll fget(int pos) {
		if(pos == 0)
			return 0;
			
		return data[pos] + fget(pos - (pos & -pos) );
	}
	
	
	//Segment addition
	void fadd(int pos, int toadd) {
		if(pos >= N)
			return;
		
		data[pos] += toadd;
		fadd(pos + (pos & -pos), toadd);
	}
};


//Main function

int n, m, p, o, p1, p2;
ftree<100001> tree;



int main () {
	cin.sync_with_stdio(false);
	
	cin >> n >> m;
	
	for(int i=1; i<=n; i++)
		cin >> p, tree.fadd(i, p);
	
	
	for(int OPERATION = 0; OPERATION  < m; OPERATION++) {
		cin >> o >> p1 >> p2;
		
		if(o == 1)
			tree.fadd(p1, p2);
		else if(o == 2)
			tree.fadd(p1, p2 - (tree.fget(p1) - tree.fget(p1-1) ) );
		else
			cout << tree.fget(p2) - tree.fget(p1 - 1) << '\n';
	}
	
	return 0;
}





























